const char P_time[] PROGMEM =  R"=====(
<html>
    <head>
        <!--meta name = "viewport" content = "width=device-width, initial-scale=1.0"-->
        <meta http-equiv = "Content-type" content = "text/html; charset=utf-8">
        <title>Led_clock_weath на ESP-12 ver:11.11.2018 (By IvanUA)</title>
        <link rel="shortcut icon" href="#" />
        <link rel = "stylesheet" type = "text/css" href = "/style.css">
        <script type = "text/javascript" src = "/function.js"></script>
        <script type = "text/javascript">
            function set_ntp(submit) {
                server = "/ntp?ntpServerName=" + val('ntpServerName') + "&timeZone=" + val('timeZone') + "&isDayLightSaving=" + val_sw('isDayLightSaving');
                send_request(submit,server);
            }
            function set_ntp_auto(submit) {
                var set_date = new Date();
                var gmtHours = -set_date.getTimezoneOffset()/60 - (val_sw('isDayLightSaving'));
                document.getElementById('timeZone').value = gmtHours;
                server = "/ntp?ntpServerName=" + val('ntpServerName') + "&timeZone=" + gmtHours + "&isDayLightSaving=" + val_sw('isDayLightSaving');
                send_request(submit,server);
            }
        </script>
    </head>
    <body onload = "load();">
        <header>
            <span class="opt_cn">CLOCK on ESP-12 ver: 11/11/2018 (by IvanZah)</span><br>
            <span class="opt_cn">Time on ESP:</span>
            <span id="time">{{time}}</span> 
        </header>       
        <central-unit>
            <div class="menu_unit">
                <a class="link__img" href="/index.html"><span class="ico__text">Wifi</span></a>
                <a class="link__img" href="/time.html"><span class="ico__text">Time</span></a>
                <a class="link__img" href="/mqtt.html"><span class="ico__text">Mqtt</span></a>
                <a class="link__img" href="/weather.html"><span class="ico__text">Weather</span></a>
                <a class="link__img" href="/led.html"><span class="ico__text">Setup</span></a>
                <a class="link__img" href="/help.html"><span class="ico__text">Help</span></a>
                <a class="link__img" href="#"><span class="ico__text" onclick="restart(this,'ResetESP?');">Restart</span></a>
            </div>
            <titles>
                <div class="opt_cn">Time setting</div>
            </titles>
            <div id="main_unit">
                <paragraph><span class="opt_cn">The exact time server for example "time.nist.gov"</span></paragraph>
                <span class="opt_cn">Enter the server address</span>
                <input type="text" class="field" id="ntpServerName" value="{{ntpServerName}}" class="form-control" pattern="[0-9a-zA-Z. ]{1,20}"><br>
                <span class="opt_cn">Choose a time zone</span>
                <select id = "timeZone">
                    <option value="-12.00"> (GMT) -12:00 </option>
                    <option value="-11.00"> (GMT) -11:00 </option>
                    <option value="-10.00"> (GMT) -10:00 </option>
                    <option value="-9.00" > (GMT) -09:00 </option>
                    <option value="-8.00" > (GMT) -08:00 </option>
                    <option value="-7.00" > (GMT) -07:00 </option>
                    <option value="-6.00" > (GMT) -06:00 </option>
                    <option value="-5.00" > (GMT) -05:00 </option>
                    <option value="-4.00" > (GMT) -04:00 </option>
                    <option value="-3.50" > (GMT) -03:30 </option>
                    <option value="-3.00" > (GMT) -03:00 </option>
                    <option value="-2.00" > (GMT) -02:00 </option>
                    <option value="-1.00" > (GMT) -01:00 </option>
                    <option value="0.00"  > (GMT) +00:00 </option>
                    <option value="1.00"  > (GMT) +01:00 </option>
                    <option value="2.00"  > (GMT) +02:00 </option>
                    <option value="3.00"  > (GMT) +03:00 </option>
                    <option value="3.50"  > (GMT) +03:30 </option>
                    <option value="4.00"  > (GMT) +04:00 </option>
                    <option value="4.50"  > (GMT) +04:30 </option>
                    <option value="5.00"  > (GMT) +05:00 </option>
                    <option value="5.50"  > (GMT) +05:30 </option>
                    <option value="5.75"  > (GMT) +05:45 </option>
                    <option value="6.00"  > (GMT) +06:00 </option>
                    <option value="6.50"  > (GMT) +06:30 </option>
                    <option value="7.00"  > (GMT) +07:00 </option>
                    <option value="8.00"  > (GMT) +08:00 </option>
                    <option value="8.50"  > (GMT) +08:30 </option>
                    <option value="8.75"  > (GMT) +08:45 </option>
                    <option value="9.00"  > (GMT) +09:00 </option>
                    <option value="9.50"  > (GMT) +09:30 </option>
                    <option value="10.00" > (GMT) +10:00 </option>
                    <option value="10.50" > (GMT) +10:30 </option>
                    <option value="11.00" > (GMT) +11:00 </option>
                    <option value="12.00" > (GMT) +12:00 </option>
                    <option value="12.75" > (GMT) +12:45 </option>
                    <option value="13.00" > (GMT) +13:00 </option>
                    <option value="14.00" > (GMT) +14:00 </option>
                </select>
                <br>
                <label class="switch"><span class="opt_cn">Daylight Saving Time</span>
                    <input type="checkbox" id="isDayLightSaving">
                    <span class="switch-btn"></span>
                </label>
                <br>
                <br>
                <span class="save_booton" onclick="set_ntp(this);">Save</span>
                <br>
                <span class="save_booton" onclick="set_ntp_auto(this);">Belt out of PC and saving</span>
            </div>
            <div>
                <a href="http://forum.amperka.ru/threads/%D0%A7%D0%B0%D1%81%D1%8B-%D0%BD%D0%B0-esp-01-nodemcu-max7219-web-%D0%B8%D0%BD%D1%82%D0%B5%D1%80%D1%84%D0%B5%D0%B9%D1%81.12767/">Forum</a>
                <a href="https://github.com/IZ76/ESP8266_Clock_Weather-station_Informer_with_WEB_interface" class = "right">GitHub</a>
            </div>
        </central-unit>
    </body>
</html>
)=====";
